﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;


using Infragistics.Controls.Menus;

namespace WpfApplication1
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();

            xamDataTree.SelectionSettings.NodeSelection = TreeSelectionType.Multiple;

            xamDataTree.Loaded+=new RoutedEventHandler(xamDataTree_Loaded);
        }

        private void xamDataTree_Loaded(object sender, RoutedEventArgs e)
        {
            Infragistics.Controls.Menus.XamDataTree tree = (Infragistics.Controls.Menus.XamDataTree)sender;

            //Added to verify that DataContext and xamDataTree's ItemSource is available - shouldn't need to set the xamDataTree ItemSource again
            ViewModel vm = this.DataContext as ViewModel;
            //tree.ItemsSource = vm.TreeSource;
            ObservableCollection<Parent> vmParent = tree.ItemsSource as ObservableCollection<Parent>;            
            //tree.ItemsSource = vmParent;

            // having to set this again to make the collection show up 
            //tree.ItemsSource = viewModel.CaseCollection;           

            //foreach (Infragistics.Controls.Menus.XamDataTreeNode tn in tree.Nodes)
            //{
            //    if (tn.Data is CaseList)
            //    {
            //        foreach (Infragistics.Controls.Menus.XamDataTreeNode cn in tn.Nodes)
            //        {
            //            if (cn.Data is UTPFCase)
            //            {
            //                UTPFCase c = (UTPFCase)cn.Data;
            //                if (c.FilePath == Properties.Settings.Default.LastUsedCaseFilePath)
            //                {
            //                    tn.IsExpanded = true; // expand the parent node
            //                    cn.IsActive = true;
            //                    cn.IsSelected = true;
            //                    break;
            //                }
            //            }
            //        }
            //    }
            //}


            XamDataTreeNodesCollection ncoll = xamDataTree.Nodes;
            foreach (Infragistics.Controls.Menus.XamDataTreeNode tn in tree.Nodes)
            {
                if (tn.HasChildren)
                {
                    tn.IsExpanded = true;
                    //tn.IsSelected = true;
                    tree.SelectionSettings.SelectedNodes.Add(tn);
                    //tn.IsActive = true;

                    foreach (Infragistics.Controls.Menus.XamDataTreeNode tnchild in tn.Nodes)
                    {
                        //tnchild.IsSelected = true;
                        tree.SelectionSettings.SelectedNodes.Add(tnchild);                       
                    }
                }
                
            }

            int selectedNodeCount = tree.SelectionSettings.SelectedNodes.Count;
            System.Diagnostics.Debug.WriteLine("SelectedNodes count = " + selectedNodeCount.ToString());
        }
    }
}
