﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace WpfApplication1
{
    class ViewModel
    {
        public ObservableCollection<Parent> TreeSource { get; set; }       
        public ViewModel()
        {
            TreeSource = new ObservableCollection<Parent>();           

            for (int i = 1; i < 6; i++)
            {
                Parent p = new Parent() { ID = i, Name = "Parent " + i.ToString(), IsChecked = false, Children = new ObservableCollection<Child>() };
                for (int j = 0; j < 10; j++)
                {
                    p.Children.Add(new Child() { ID = (i * 10) + j, IsChecked = false, Name = "Child " + i + j });
                }
                TreeSource.Add(p);
            }           
        }
    }

    public class Parent : INotifyPropertyChanged
    {
        private int id;
        private string name;
        private bool isChecked;
        private ObservableCollection<Child> children;

        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }
        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public bool IsChecked
        {
            get { return isChecked; }
            set
            {
                if (isChecked != value)
                {
                    isChecked = value;
                    OnPropertyChanged("IsChecked");
                }
            }
        }
        public ObservableCollection<Child> Children
        {
            get { return children; }
            set
            {
                if (children != value)
                {
                    children = value;
                    OnPropertyChanged("Children");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
    public class Child : INotifyPropertyChanged
    {
        private int id;
        private string name;
        private bool isChecked;

        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }
        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }
        public bool IsChecked
        {
            get { return isChecked; }
            set
            {
                if (isChecked != value)
                {
                    isChecked = value;
                    OnPropertyChanged("IsChecked");
                }
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
